#ifndef BTRACE_H
#define BTRACE_H
/*
 * btrace.h -- debugging utility that provides printings of the backtrace of
 * the current function.
 * $Id: btrace.h,v 1.3 2000/10/13 00:00:59 rwx Exp $
 */

#include <execinfo.h>
#include <sys/types.h>

/*
 * Our global symbol and addresses table.
 */
typedef struct btrace_st_tag {
	u_char *name;		/* symbol name */
	void *begin, *end;	/* start and end addresses respectively */
} btrace_st_t;

btrace_st_t *btrace_st;

u_int btrace_level;

/*
 * initializes the global structures that btrace needs
 */
/*
 * The function btrace() initializes the global symbol table reading all the
 * symbols related to functions present in the executable image. It will not
 * work if the executable has been stripped.
 * If the environment variable BTRACE_LEVEL is set it will specify the depth of
 * the backtrace.
 */
/*
 * Returns: nothing, if something goes wrong it simply abort()s.
 */
extern void btrace(void);

/*
 * prints a backtrace of function names and addresses
 */
/*
 * The function btrace_print() prints the trace of functions calling the
 * current function in a similar fashion as gdb's backtrace command.
 */
/*
 * Returns: nothing, if something goes wrong you'd better wave a dead chicken
 * over it.
 */
extern void btrace_print(void);

#endif /* !BTRACE_H */
